//Author:    Timothy Pearson <kb9vqf@pearsoncomputing.net>, (C) 2014
//Copyright: See COPYING file that comes with this distribution

#ifndef REMOTELAB_SERIALCONSOLEPART_H
#define REMOTELAB_SERIALCONSOLEPART_H

#include <tdeparts/browserextension.h>
#include <tdeparts/statusbarextension.h>
#include <tdeparts/part.h>
#include <kurl.h>

#include <tqtrla.h>

class TDEAboutData;
using KParts::StatusBarExtension;
class TraceWidget;
class TQSocket;
class TQTimer;
class TQMutex;
class TQRectF;
class SerialConsoleBase;

namespace RemoteLab
{
	class SerialConsolePart : public KParts::RemoteInstrumentPart
	{
		Q_OBJECT
	
		public:
			SerialConsolePart( QWidget *, const char *, TQObject *, const char *, const TQStringList&);
			~SerialConsolePart();
	
			virtual bool openFile() { return false; }	// pure virtual in the base class
			virtual bool closeURL();
			static TDEAboutData *createAboutData();

		public slots:
			virtual bool openURL(const KURL &url);
		
		private slots:
			void postInit();
			void processLockouts();
			void connectionFinishedCallback();
			void disconnectFromServerCallback();
			void connectionStatusChangedCallback();
			void setTickerMessage(TQString message);
			void mainEventLoop();
			void sendTextClicked();
	
		private:
			int m_commHandlerState;
			int m_commHandlerMode;
			int m_commHandlerCommandState;
			TQTimer* m_forcedUpdateTimer;
			TQTimer* m_updateTimeoutTimer;
			bool m_connectionActiveAndValid;
			unsigned char m_tickerState;
			SerialConsoleBase* m_base;
			TQMutex* m_instrumentMutex;
			TQString m_TextToSend;
	};
}

#endif
